PROCEDURE AllTags
PARAMETERS nPopRow, nPopCol
* Creates a popup of all available index tags in the currently selected file
* Parameters: row and column - both numeric

  PRIVATE nBarNumber, cPrompt

  * Disable left/right arrow keys (to prevent an accidental exit)
  ON KEY LABEL LEFTARROW  ?? CHR(7)
  ON KEY LABEL RIGHTARROW ?? CHR(7)

  DEFINE POPUP TagPop FROM nPopRow, nPopCol ;
    MESSAGE "Press ENTER to select new index order...Esc to exit..."

  nBarNumber = 1
  cPrompt    = "NO INDEX"

  DO WHILE  "" <> cPrompt
    DEFINE BAR nBarNumber OF TagPop PROMPT (cPrompt)
    cPrompt = TAG(nBarNumber)
    nBarNumber = nBarNumber + 1
  ENDDO

  ON SELECTION POPUP TagPop DEACTIVATE POPUP
  ACTIVATE POPUP TagPop

  * Assign a null string to cPrompt if "NO INDEX" selected
  cPrompt = IIF(BAR() = 1, "",PROMPT())

  * Don't change index order if Esc pressed
  IF BAR() <> 0
    SET ORDER TO (cPrompt)
  ENDIF

  RELEASE POPUP TagPop

  * Enable left/right arrow keys
  ON KEY LABEL LEFTARROW
  ON KEY LABEL RIGHTARROW
  RETURN

* EOF: AllTags

