*:*********************************************************************
*:
*: Procedure file: C:\CLASS5\GENBROW1.PRG
*:
*:         System: Browse Generator
*:         Author: George F. Goley IV
*:      Copyright (c) 1991, Micro Endeavors Inc.
*:  Last modified: 09/26/91      0:41
*:
*:  Procs & Fncts: GENBROWACT()
*:               : GENBROW1A
*:
*:          Calls: GENBROWACT()   (function  in GENBROW1.PRG)
*:
*:      Documented 09/26/91 at 06:35               FoxDoc  version 2.10
*:*********************************************************************
* genbrow1.prg
* Generates a BROWSE command from a screen file.

** brgenfil = name of screen file, if not passed,
**            program will prompt user for name
** broutfil = name of program to generate
PARAMETERS brgenfil,broutfil

PRIVATE oldtalk,oldsafe
oldtalk=SET('talk')
oldsafe=SET('safe')
SET TALK OFF
SET SAFE OFF
brgenfil=IIF(TYPE('brgenfil')#"C","",brgenfil)
brgenfil=IIF("."$brgenfil,LEFT(brgenfil,AT(".",brgenfil)-1),brgenfil)
broutfil= PADR(SYS(5)+SYS(2003)+"\"+ brgenfil+".spr",80)
brgenfil=PADR(SYS(5)+SYS(2003)+"\"+brgenfil+".scx",80)


IF NOT WEXIST("genbrow1")
   DEFINE WINDOW genbrow1 ;
      FROM INT((SROW()-6)/2),INT((SCOL()-78)/2) ;
      TO INT((SROW()-6)/2)+5,INT((SCOL()-78)/2)+77 ;
      TITLE "Browse Command Generation" ;
      FOOTER "Ctrl-W to save, Escape to Exit" ;
      FLOAT ;
      CLOSE ;
      SHADOW ;
      MINIMIZE ;
      SYSTEM ;
      COLOR SCHEME 1
ENDIF


IF WVISIBLE("genbrow1")
   ACTIVATE WINDOW genbrow1 SAME
ELSE
   ACTIVATE WINDOW genbrow1 NOSHOW
ENDIF
@ 0,0 SAY "Enter Screen File:"
@ 1,0 SAY "Enter Output File:"
@ 0,19 GET brgenfil ;
   SIZE 1,56  ;
   DEFAULT " "
@ 1,19 GET broutfil ;
   SIZE 1,56  ;
   DEFAULT " "
@ 3,25 GET action ;
   PICTURE "@*HN \!\<Generate;\?\<Cancel" ;
   SIZE 1,10,1 ;
   DEFAULT "" ;
   VALID genbrowact(action)

IF NOT WVISIBLE("genbrow1")
   ACTIVATE WINDOW genbrow1
ENDIF

READ CYCLE

RELEASE WINDOW genbrow1
IF oldtalk#"OFF"
   SET TALK ON
ENDIF
IF oldsafe#"OFF"
   SET SAFE ON
ENDIF

*!*********************************************************************
*!
*!       Function: GENBROWACT()
*!
*!      Called by: GENBROW1.PRG                  
*!
*!          Calls: GENBROW1A      (procedure in GENBROW1.PRG)
*!
*!*********************************************************************
PROCEDURE genbrowact
* genbrow action valid clause
* Triggered when they choose an action
PARAMETERS action
DO CASE
CASE UPPER(action)="CANCEL"
   CLEAR READ
CASE UPPER(action)="GENERATE"
   DO genbrow1a
ENDCASE
SHOW GETS
RETURN .T.



*!*********************************************************************
*!
*!      Procedure: GENBROW1A
*!
*!      Called by: GENBROWACT()   (function  in GENBROW1.PRG)
*!
*!          Calls: L2MSG()        (function  in L2MSG.PRG)
*!
*!*********************************************************************
PROCEDURE genbrow1a
* generate the browse command
PRIVATE olderror,curworkarea,gbarr,gbqty,gberror,gbkey,gbflds
IF !FILE(brgenfil)                       && he didn't pick a valid screen file
   ** use built-in GETFILE() function to prompt for a valid SCX
   brgenfil=GETFILE('SCX', "Please select a valid screen file:")
   ** show user the selected file name
   SHOW GET brgenfil
ENDIF
IF !FILE(brgenfil)
   ** he still hasn't picked a valid SCX, so send him back
   ** to the read
   brgenfil=PADR(brgenfil,80)
   ** put him in the brgenfil field!
   _CUROBJ=OBJNUM(brgenfil)
   RETURN .T.
ENDIF   didn't pick a valid SCX file
** check to see if he chose a file that already exists
IF FILE(broutfil)
   ** see if he wants to overwrite it.
   IF l2msg(TRIM(broutfil)+" already exists. Overwrite?","YES|NO")="NO"
      _CUROBJ=OBJNUM(broutfil)             && put cursor in output file
      RETURN .T.
   ENDIF   does not want to overwrite
ENDIF   output already exists
** create a window in which the user can "watch" the generation
DEFINE WINDOW showoff FROM 1,0 TO 23,75 TITLE TRIM(broutfil) SHADOW
ACTIVATE WINDOW showoff
** setup an error trap in case he chose an invalid out file
olderror=ON("ERROR")                     && save current error trap
ON ERROR gberror=ERROR()
gberror=0
** send output to the selected outfile
SET TEXTMERGE TO (TRIM(broutfil))
** reset error trap
ON ERROR &olderror.
** check for the possible error
IF gberror#0
   ** he chose an invalid output file
   DO l2msg WITH "Please select a valid output file.","Continue"
   _CUROBJ=OBJNUM(broutfil)               && put cursor in broutfil
   RETURN .F.
ENDIF   an error
IF !USED('BRGENFIL')
   ** open the output file under the alias brgenfil
   ** use the again clause in case the SCX is already open
   ** under another alias
   USE (brgenfil) ALIAS brgenfil AGAIN IN SELECT(1)
ENDIF   brgenfil not already in use
SELECT brgenfil
** activate the textmerge
SET TEXTMERGE ON
** because the next three commands are preceded by a
** back slash, they are output to the (broutfil) file
\* <<broutfil>>
\*
\* open database
curworkarea=""   && master alias for this BROWSE
SCAN FOR objtype=2                       && work area
   ** the SCX file has one record with an objtype of
   ** 2 for each active work area. These databases are saved
   ** when the user of the screen painter elects to
   ** SAVE ENVIRONMENT
   
   \IF !USED("<<tag>>")
   \  USE <<name>> ALIAS <<tag>> IN SELECT(1)
   \ENDIF alias <<tag>> not in use
   ** establish a master order for this database if
   ** the SCX file has an order in the tag2 field
   
   IF !EMPTY(tag2)
      \SET ORDER TO <<tag2>> IN <<tag>>
   ENDIF   a master order is established for this work area
   \
   
   ** the work area that will be the current work area
   ** has a .T. value in the SCX file's "Unique" field
   curworkarea=IIF(UNIQUE,TAG,curworkarea)
   
ENDSCAN   saved the environment
** gbarr is an array created to hold up to 25 active alias names
DIMENSION gbarr(25)
gbarr=""                                 && alias names
gbqty=1                                  && number of next gbarr element to hold an alias
gbkey=""
** establish any relationships
SCAN FOR objtype = 4                     && relationships
   \SELECT <<tag2>>
   IF ASCAN(gbarr,UPPER(tag2))=0
      ** new alias, so erase any prior relationships emanating
      ** from this alias
      \SET RELATION TO
      ** put new alias into array
      gbarr(gbqty)=UPPER(tag2)
      gbqty=gbqty+1
   ENDIF   this is the first relationship for this alias
   ** do the relation
   \SET RELATION TO <<expr>> INTO <<tag>> ADDITIVE
   ** see if the target of this relation is the master
   ** alias for this browse
   IF UPPER(TAG)==UPPER(curworkarea)
      ** establish a browse key for this browse
      gbkey=expr
   ENDIF
ENDSCAN
** issue any necessary set skips
SCAN FOR objtype =2 AND !EMPTY(expr)
   \SELECT <<tag>>
   \SET SKIP TO <<expr>>
ENDSCAN
** select the current work area
IF !EMPTY(curworkarea)
   \SELECT <<curworkarea>>
ENDIF   there is a current work area
\
** now create the window we need
SCAN FOR objtype=1                       && screen
   \DEFINE WINDOW <<name>> ;
   IF CENTER
      \  FROM INT((SROW()-<<Height>>)/2),
      \\INT((SCOL()-<<Width>>)/2) ;
      \  TO INT((SROW()-<<Height>>)/2)+<<Height-1>>,
      \\INT((SCOL()-<<Width>>)/2)+<<Width-1>>
   ELSE
      \  FROM <<Vpos>>, <<Hpos>> ;
      \  TO <<Height+Vpos-1>>,<<Width+Hpos-1>>
   ENDIF
   IF !EMPTY(TAG)
      \\ ;
      \  TITLE <<tag>>
   ENDIF   title
   IF !EMPTY(tag2)
      \\ ;
      \ FOOTER <<tag2>>
   ENDIF   footer
   opts=IIF(FLOAT," FLOAT ","")+;
      IIF(CLOSE," CLOSE ","")+;
      IIF(MINIMIZE," MINIMIZE ","")+;
      IIF(SHADOW," SHADOW ","")+;
      IIF("#GROW"$SETUPCODE," GROW ","")+;
      IIF("#ZOOM"$SETUPCODE," ZOOM ","")+;
      " "+ALLTRIM(SUBSTR("NONE        DOUBLEPANEL SYSTEM",;
      BORDER*6+1,BORDER*6+6))+" "
   \\ ;
   \ <<opts>>
ENDSCAN
** get number of fields
COUNT TO qtyflds FOR objtype=15
** create an array for the browse field stuff
DIMENSION gbflds(qtyflds,10)
gbflds=""
** put field information into the array first
curfld=1
SCAN FOR objtype=15
   ** if the field is an expression, treat it as a calculated
   ** field with a name like T001 - T999
   gbflds(curfld,1)=IIF(objcode=1,"","t"+;
      PADL(LTRIM(STR(curfld)),3,"0")+"="+expr)  && calculated field
   gbflds(curfld,2)=IIF(objcode=1,name,"")  && field name
   gbflds(curfld,3)=VALID
   gbflds(curfld,4)=ERROR
   gbflds(curfld,5)=PICTURE
   gbflds(curfld,6)=WHEN
   gbflds(curfld,7)=IIF(disabled,":R","")
   gbflds(curfld,8)=WIDTH
   curfld=curfld+1
ENDSCAN
** now put headers in
curfld=1
SCAN FOR objtype=5
   gbflds(curfld,9)=expr                  && header
   curfld=curfld+1
ENDSCAN

** Find the "READ" object in the SCX file
LOCATE FOR objtype=1

** I assume that you want the NOWAIT clause to make it easier to
** connect this BROWSE window with a READ CYCLE. If I am incorrect,
** take it out!
\BROWSE NOWAIT ;

** If this work area is the target of a relation,
** create a browse KEY argument automatically
IF !EMPTY(gbkey)
   \  KEY <<gbkey>> ;
ENDIF  not an empty key
** Read level activate clause has any optional browse stuff like
** NORGRID, PARTITION, etc.
IF !EMPTY(ACTIVATE)
   \  <<activate>> ;
ENDIF  not an empty activate
IF !EMPTY(name)   && a window was created in the SCX
   \  WINDOW <<name>> ;
ENDIF

IF !EMPTY(VALID)  && Read level valid becomes Browse Valid
   \  VALID <<valid>> ;
ENDIF

IF !EMPTY(WHEN)  && Read level when becomes browse when
   \  WHEN <<when>> ;
ENDIF

\  FIELDS
** put field info we stuffed into the gbflds array
** into the BROWSE command
FOR xx =1 TO qtyflds
   ** add a comma if this isn't the first field
   \\ <<iif(xx>1,",","")>> ;
   ** Put both the expression and the field name in,
   ** after all ONLY ONE WILL HAVE A VALUE!
   \  <<gbflds(xx,1)+gbflds(xx,2)>>
   
   IF !EMPTY(gbflds(xx,8))                && size
      \\ :<<gbflds(xx,8)>>
   ENDIF
   
   IF !EMPTY(gbflds(xx,7))                && read only clause
      \\ :R
   ENDIF
   
   IF !EMPTY(gbflds(xx,5))                && picture clause
      \\ ;
      \  :P=<<gbflds(xx,5)>>
   ENDIF
   
   IF !EMPTY(gbflds(xx,3))                && valid clause
      \\ ;
      \  :V=<<gbflds(xx,3)>>
   ENDIF
   
   IF !EMPTY(gbflds(xx,4))                && error clause
      \\ ;
      \  :E=<<gbflds(xx,4)>>
   ENDIF
   
   IF !EMPTY(gbflds(xx,6))                && when clause
      \\ ;
      \  :W=<<gbflds(xx,6)>>
   ENDIF
   
   ** field header, or use field name by default
   \\ ;
   IF EMPTY(gbflds(xx,9))
      \  :H="<<gbflds(xx,1)+gbflds(xx,2)>>"
   ELSE
      \  :H=<<gbflds(xx,9)>>
   ENDIF  no header
ENDFOR
\
\* eof <<broutfil>>

** Discontinue output to broutfil
SET TEXTMERGE OFF
SET TEXTMERGE TO
** close the SCX file
USE IN brgenfil
** brag a little
WAIT WINDOW "Generation complete"
** compile the output program
COMPILE (TRIM(broutfil))
** look for an error file
IF FILE(TRIM(LEFT(broutfil,AT(".",broutfil)))+"ERR")
   ** let them see the error
   MODIFY FILE (TRIM(LEFT(broutfil,AT(".",broutfil)))+"ERR") NOWAIT
   ** let them fix the error in the screen file
   MODIFY SCREEN (brgenfil) NOWAIT
ENDIF
RELEASE WINDOW showoff
RETURN .T.
*: EOF: GENBROW1.PRG
