*:*********************************************************************
*:
*: Procedure file: C:\CLASS5\L2MSG.PRG
*:
*:         System: Browse Generator
*:         Author: George F. Goley IV
*:      Copyright (c) 1991, Micro Endeavors Inc.
*:  Last modified: 06/09/91      6:37
*:
*:  Procs & Fncts: L2MSG()
*:
*:      Documented 09/26/91 at 06:35               FoxDoc  version 2.10
*:*********************************************************************
* l2msg.prg
* Foxpro Version
*& displays message and prompts for action
** msg = message to be displayed. Use "|" for line break.
** options = choices for user delimited by "|" or by ";"
**           preceed default option with "\!", hot keys can
**           be established with "\<"
** msgtitle = "title for window"
** msgrow = upper row for window
** msgcol = left column for window
** winwidth = user specified width
** winheight = user specified height
** msgopts = options for display of window
**           if first two characters are numeric betweeen 01
**           and 24, lbmsg will use these as the color scheme (7 default)
**           if includes "L", message will be left justified (Default)
**           if includes "C", message will be centered
**           if includes "R", message will be right justified
**           if includes "TIME=", timeout clause will be enabled on READ
** msgcolor = color pairs for scheme
*
** sample usage: ans=lbmsg("Is this ok?","YES|NO","VERIFY",1,0,20)
**               ans=lbmsg("Invalid option.","CONTINUE")
PARAMETERS msg,options,msgtitle,msgrow,msgcol,winwidth,winheight,msgopts,msgcolor
PRIVATE winrcol,optlines,msglines,oldmsgwide,winlrow
PRIVATE thisopt,retopt,xx,retval,curwinout,msgcolor,msgjust,oldtalk
PRIVATE thistime,thisstart
oldtalk=SET('talk')
SET TALK OFF
IF TYPE('msgcolor')#"C"
   msgcolor=IIF(TYPE('msgopts')="C".AND.VAL(msgopts)>0,;
      VAL(msgopts),7)
ENDIF
msgjust="L"
IF TYPE('msgopts')="C"
   DO CASE
   CASE "C"$msgopts
      msgjust="C"
   CASE "L"$msgopts
      msgjust="L"
   CASE "R"$msgopts
      msgjust="R"
   OTHERWISE
      msgjust="L"
   ENDCASE
ENDIF    passed me some messages
curwinout=WOUTPUT()
*$ convert "|" to chr(13) in msg
msg = STRTRAN(msg,"|",CHR(13))
*$ determine width
oldmsgwide=SET("memowidth")
IF TYPE('winwidth')#"N"
   ** width not passed
   winwidth = MIN(SCOLS(),oldmsgwide+2)
ELSE
   SET MEMOWIDTH TO winwidth
ENDIF
*$ determine upper left column
IF TYPE('msgcol')#"N"
   msgcol = (SCOLS()-winwidth)/2
ENDIF
winrcol = msgcol+winwidth+2
*$ determine number of options rows
IF TYPE('options')="C"
   options1=CHRTRAN(options," ",CHR(255))
   optlines=MEMLINES(CHRTRAN(options1,"|"," "))
ELSE
   optlines=0
ENDIF
**optlines = iif(type('options')="C",int(len(options)/winwidth)+1,0)
*$ number of message rows
IF TYPE('winheight')#"N"
   msglines = MAX(1,MIN(SROWS()-optlines-3,MEMLINES(msg)))
ELSE
   msglines = MAX(1,MIN(SROWS()-optlines-3,MAX(MEMLINES(msg),;
      winheight-optlines-2)))
ENDIF    rows were not passed
*$ determine requested rows
IF TYPE('msgrow')#"N"
   msgrow = INT((SROWS()-(msglines+optlines+2))/2)
ENDIF    passed rows by request
winlrow = msgrow+msglines+optlines+2
*$ create window
IF TYPE('msgtitle')#"C"
   msgtitle="NOTE"
ENDIF    no title passed
IF TYPE('msgcolor')="N"
   DEFINE WINDOW lbmsg FROM msgrow,msgcol TO winlrow,winrcol ;
      COLOR SCHEME msgcolor TITLE msgtitle  FLOAT SHADOW SYSTEM
ELSE
   DEFINE WINDOW lbmsg FROM msgrow,msgcol TO winlrow,winrcol ;
      COLOR &msgcolor. TITLE msgtitle  FLOAT SHADOW SYSTEM
ENDIF    use scheme
ACTIVATE WINDOW lbmsg TOP
*$ put up prompts
options=ALLTRIM(options)
retopt=SPACE(LEN(options))
** convert "|" to ";" for prompt
options=CHRTRAN(options,"|",CHR(59))
** make sure there are no leading or trailing delimiters
IF RIGHT(options,1)=CHR(59)
   options = LEFT(options,LEN(options)-1)
ENDIF    closing delimiter
IF LEFT(options,1)=CHR(59)
   options = SUBSTR(options,2)
ENDIF    opening delimiter
@ WROWS()-1,0 GET retopt FUNCTION "*H "+options SIZE 1,1
IF "\!"$options                            && default value
   thisstart=OCCURS(CHR(59),LEFT(options,AT("\!",options)))+1
ELSE
   thisstart=1
ENDIF    has a default value
*$ put message lines in the window
DO CASE
CASE msgjust="C"
   @ 0,0 EDIT msg SIZE WROWS()-optlines-1,winwidth ;
      SCROLL NOMODIFY FUNCTION "I"
CASE msgjust="L"
   @ 0,0 EDIT msg SIZE WROWS()-optlines-1,winwidth ;
      SCROLL NOMODIFY
CASE msgjust="R"
   @ 0,0 EDIT msg SIZE WROWS()-optlines-1,winwidth ;
      SCROLL NOMODIFY FUNCTION "J"
ENDCASE
** determine timeout if any
IF TYPE('msgopts')="C" .AND. "TIME="$UPPER(msgopts)
   thistime=VAL(SUBSTR(msgopts,ATC("TIME=",msgopts)+5))
ELSE
   thistime=0
ENDIF
READ CYCLE OBJECT (thisstart) TIMEOUT thistime MODAL
RELEASE WINDOW lbmsg
SET MEMOWIDTH TO oldmsgwide
IF oldtalk#"OFF"
   SET TALK ON
ENDIF
RETURN retopt

*: EOF: L2MSG.PRG
