// Example use of TBrowseArray()
// Browse names of files in current directory

#include "directry.ch"
#xtrans GetSetBlock( <v> ) => {|x| IIf( x==NIL,<v>,<v>:= x ) }

LOCAL aDir:= Directory( "*.*" )
LOCAL i,tba

// Create TBrowse configured for an array
tba:= TBrowseArray( 10,20,15,32,aDir,GetSetBlock( i ) )

// Define a column for viewing file names
c:= TBColumnNew( "File Name", {|| aDir[ i ][ F_NAME ] } )

// Force width to 12 screen columns
c:width:= 12

tba:addColumn( c )
@ 09,18 CLEAR TO 16,33 
@ 09,18 TO 16,33 DOUBLE

TBKeyProcess( tba )
RETURN

// Process user keystrokes
FUNCTION TBKeyProcess( b )
   LOCAL nKey
   WHILE .T.
      WHILE !b:stabilize()
         IF NextKey() <> 0
            EXIT
         ENDIF
      END
      nKey:= InKey( 0 )
      DO CASE
      CASE nKey==K_UP;    b:up()
      CASE nKey==K_DOWN;  b:down()
      CASE nKey==K_PGUP;  b:pageUp()
      CASE nKey==K_PGDN;  b:pageDown()
      CASE nKey==K_HOME;  b:goTop()
      CASE nKey==K_END;   b:goBottom()
      CASE nKey==K_ENTER; EXIT
      CASE nKey==K_ESC;   EXIT
      ENDCASE
   END
   RETURN nKey

